/****************************************************************************
File    : HardwareDlg.h
/*
@(#) #SY# Atari800Win
@(#) #IS# Interface of the CHardwareDlg class
@(#) #BY# Richard Lawrence, Harry (modifications and code maintenance)
@(#) #LM# 26.02.2000
*/

#ifndef __HARDWAREDLG_H__
#define __HARDWAREDLG_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


/////////////////////////////////////////////////////////////////////////////
// CHardwareDlg specific const definitions

#define MACHINE_TYPES	7


/////////////////////////////////////////////////////////////////////////////
// CHardwareDlg dialog

class CHardwareDlg : public CDialog
{
// Construction
public:
	CHardwareDlg( CWnd *pParent = NULL );   // standard constructor

// Interface: operations
public:

// Interface: attributes
public:

// Dialog Data
	//{{AFX_DATA(CHardwareDlg)
	enum { IDD = IDD_HARDWARE };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Implementation: operations
private:
	void SetDlgState( void );

// Implementation: overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHardwareDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation: attributes
private:
	int   m_nRefreshRate;
	int   m_nDefaultTVMode;
	int   m_nGlobalArtifMode;
	int   m_nEnableRomPatches;
	int   m_nEnableSIOPatch;
	int   m_nEnableC000Ram;
	int   m_nUseNewBinload;
	int   m_nOrigSystem;
	int   m_nSystem;
	ULONG m_ulMiscStates;

// Generated message map functions
protected:
	//{{AFX_MSG(CHardwareDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnDeltaposRefreshSpin(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNtsc();
	afx_msg void OnPal();
	afx_msg void OnKillfocusRefreshRate();
	afx_msg void OnRomfile();
	afx_msg int OnKillfocusRomEdit();
	afx_msg void OnSelchangeMachineSelector();
	afx_msg void OnSelchangeArtifactMode();
	afx_msg void OnEnableRom();
	afx_msg void OnNewBinload();
	afx_msg void OnFullSpeed();
	afx_msg void OnEnableSio();
	afx_msg void OnC000Ram();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif //__HARDWAREDLG_H__
